"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _FilteringDropdownMenuInput = _interopRequireDefault(require("./FilteringDropdownMenuInput"));
var _optionHelpers = require("../helpers/optionHelpers");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
// TODO: Stop using propTypes in isInput, and in render method of cspace-ui Field component.
// Until then, propTypes need to be hoisted from the base component.
// eslint-disable-next-line react/forbid-foreign-prop-types
const {
  propTypes
} = _FilteringDropdownMenuInput.default;
class PrefixFilteringDropdownMenuInput extends _react.Component {
  constructor(props) {
    super(props);
    this.filter = this.filter.bind(this);
    this.handleDropdownInputCommit = this.handleDropdownInputCommit.bind(this);
    const prefix = null;
    this.state = {
      prefix,
      filteredOptions: (0, _optionHelpers.filterOptionsByPrefix)(props.options, prefix),
      value: props.value
    };
  }
  componentWillReceiveProps(nextProps) {
    const {
      options,
      value
    } = nextProps;
    this.setState(prevState => ({
      value,
      filteredOptions: (0, _optionHelpers.filterOptionsByPrefix)(options, prevState.prefix)
    }));
  }
  handleDropdownInputCommit(path, value) {
    const {
      options,
      onCommit
    } = this.props;
    const prefix = null;
    this.setState({
      prefix,
      value,
      filteredOptions: (0, _optionHelpers.filterOptionsByPrefix)(options, prefix)
    });
    if (onCommit) {
      onCommit(path, value);
    }
  }
  filter(prefix) {
    const {
      options
    } = this.props;
    this.setState({
      prefix,
      filteredOptions: (0, _optionHelpers.filterOptionsByPrefix)(options, prefix)
    });
  }
  render() {
    const {
      options,
      ...remainingProps
    } = this.props;
    const {
      filteredOptions,
      value
    } = this.state;
    return /*#__PURE__*/_react.default.createElement(_FilteringDropdownMenuInput.default
    // eslint-disable-next-line react/jsx-props-no-spreading
    , _extends({}, remainingProps, {
      filter: this.filter,
      options: filteredOptions,
      value: value,
      onCommit: this.handleDropdownInputCommit
    }));
  }
}
exports.default = PrefixFilteringDropdownMenuInput;
PrefixFilteringDropdownMenuInput.propTypes = propTypes;